// Copyright (C) 2004-2007 Tord Romstad

// This file is part of Glaurung.
//
// Glaurung is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//  
// Glaurung is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Glaurung; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#if !defined(COLOR_H_INCLUDED)
#define COLOR_H_INCLUDED

////
//// Includes
////

#include "misc.h"


////
//// Types
////

enum Color {
  WHITE, 
  BLACK, 
  COLOR_NONE
};


////
//// Constants and variables
////

const Color ColorMin = WHITE;
const Color ColorMax = BLACK;


////
//// Inline functions
////

inline Color operator+ (Color p, int i) { return Color(int(p) + i); }
inline void operator++ (Color& p, int i) { p = Color(int(p) + 1); }

inline Color opposite_color(Color color) {
  return Color(int(color) ^ 1);
}


////
//// Debug functions
////

extern bool color_is_ok(Color color);


#endif // !defined(COLOR_H_INCLUDED)
