// Copyright (C) 2004-2007 Tord Romstad

// This file is part of Glaurung.
//
// Glaurung is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//  
// Glaurung is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Glaurung; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#if !defined(TEST_H_INCLUDED)
#define TEST_H_INCLUDED

////
//// Includes
////

#include "movegen.h"
#include "position.h"


////
//// Types
////

class Test {
  
public:
  // 'perft' and 'divide'
  static uint64 perft(Position& pos, int depth);
  static void divide_perft(Position& pos, int depth);

  // Generating random positions and moves
  static void random_position(Position& pos);
  static Move random_legal_move(const Position& pos);
  static Move random_pseudo_move();
  static Move random_maybe_legal_move(const Position& pos);

  // Mirroring a position
  static void flip_position(Position& dst, const Position& src);

  // Regression tests
  static bool test_move_picker();
  static bool test_eval_symmetry();
  static bool test_see();
  static bool run_all_tests();

  // Move ordering test
  static void move_ordering_test();

};

#endif // !defined(TEST_H_INCLUDED)
